#include <simplecpp>
#include <iostream>
#include <page_layout.h>

const float canwid = 690;

Navigator navigate;

int main()
{
	initCanvas("Calculus Tools",canwid,canwid);

	//Following lines are for decorative purposes only --->

	Rectangle BG(canwid/2,canwid/2,canwid,canwid);
	BG.setColor(COLOR("Grey"));
	BG.setFill();

	/*Rectangle BG1(120,canwid/4-35,240,canwid/2-70);
    BG1.setColor(COLOR("Pink"));
    BG1.setFill();

    Rectangle BG2(120,3*canwid/4-5,240,canwid/2+10);
    BG2.setColor(COLOR("Light Blue"));
    BG2.setFill();*/

	Text heading1(100,canwid/2-60,"------------------------------------------------>>>");
	Text heading2(100,canwid/2-40,"CALCULUS TOOLS");
	Text heading3(100,canwid/2-20,"------------------------------------------------>>>");
	heading1.setColor(COLOR("Green"));
	heading2.setColor(COLOR("Red"));
	heading3.setColor(COLOR("Green"));

	Text Developers(140,canwid/2,"Developed By ");
	Text Developers1(160,canwid/2+20,"Mishal Assif     ");
	Text Developers2(160,canwid/2+30,"Saurabh Chauhan  ");
	Text Developers3(160,canwid/2+40,"Sheryl Mathew    ");
	Text Developers4(160,canwid/2+50,"Nirbhay Patil    ");
    Developers.setColor(COLOR("Blue"));

    Line l1(240,0,240,canwid/2-70);
    Line l2(240,canwid/2-10,240,canwid);
    Line l3(10,30,10,canwid/2-70);
    Line l4(10,canwid/2-10,10,canwid-30);
    l1.setColor(COLOR("Yellow"));
    l2.setColor(COLOR("Yellow"));
    l3.setColor(COLOR("Yellow"));
    l4.setColor(COLOR("Yellow"));


    Circle c1(30,30,60);
    Circle c2(30,canwid-30,60);
    Circle c3(canwid-30,30,60);
    Circle c4(canwid-30,canwid-30,60);
    c1.setColor(COLOR("Black"));
    c2.setColor(COLOR("Black"));
    c3.setColor(COLOR("Blue"));
    c4.setColor(COLOR("Blue"));
    c1.setFill();
    c2.setFill();
    c3.setFill();
    c4.setFill(); 

    Rectangle Rback(100,canwid/3.5,60,30);
    Rback.setColor(COLOR("Maroon"));
    Rback.setFill();
    Button Bback(100,canwid/3.5,60,30);
    Text Tback(100,canwid/3.5,"<--Back");
    Tback.setColor(COLOR("Blue"));

   

    //<------

    //Following Declarations are Objects used as Buttons in the program 
    //Initially none of the objects are displayed
    //According to the layout of the current page,they're hidden and displayed
    //------>

    Rectangle R1(0,0,0,0);
    Rectangle R2(0,0,0,0);
    Rectangle R3(0,0,0,0);
    Rectangle R4(0,0,0,0);
	Rectangle R5(0,0,0,0);
	Rectangle R6(0,0,0,0);

	Button B1(0,0,0,0);
	Button B2(0,0,0,0);
	Button B3(0,0,0,0);
	Button B4(0,0,0,0);
	Button B5(0,0,0,0);
	Button B6(0,0,0,0);

	Text T1(0,0,"");
	Text T2(0,0,"");
	Text T3(0,0,"");
	Text T4(0,0,"");
	Text T5(0,0,"");
	Text T6(0,0,"");


	//<------

    //Home Page Layout ----->
    B1.Reset(canwid/2+100,canwid/2-150,150,100);   //To display the buttons
    B2.Reset(canwid/2+100,canwid/2+150,150,100);
    R1.reset(canwid/2+100,canwid/2-150,150,100);
    R2.reset(canwid/2+100,canwid/2+150,150,100);
    R1.setColor(COLOR("Maroon"));
    R2.setColor(COLOR("Maroon"));
    R1.setFill();
    R2.setFill();
    T1.reset(canwid/2+100,canwid/2-150,"Two Dimensional");
    T2.reset(canwid/2+100,canwid/2+150,"Three Dimensional");
    //<------

    int click;

	while(1)
    {
	
	   click=getClick();

	   if(navigate.page_no()==0)         
	   {

	     if(B1.checkclick(click))
		 {
		 	GoFront(navigate,1);
		 	ChangeLayout_R(1,R1,R2,R3,R4,R5,R6);
		 	ChangeLayout_B(1,B1,B2,B3,B4,B5,B6);
		 	ChangeLayout_T(1,T1,T2,T3,T4,T5,T6);
		 }

		 else if(B2.checkclick(click))
		 {
		 	GoFront(navigate,2);
		 	ChangeLayout_R(2,R1,R2,R3,R4,R5,R6);
		 	ChangeLayout_B(2,B1,B2,B3,B4,B5,B6);
		 	ChangeLayout_T(2,T1,T2,T3,T4,T5,T6);
		 } 

	   }

	   else if(navigate.page_no()==1)
	   {

	   	  if(B1.checkclick(click))
	   	  {
	   	  	 GoFront(navigate,3);
	   	  	 ChangeLayout_R(3,R1,R2,R3,R4,R5,R6);
		 	 ChangeLayout_B(3,B1,B2,B3,B4,B5,B6);
		 	 ChangeLayout_T(3,T1,T2,T3,T4,T5,T6);

	   	  }

	   	   else if(B2.checkclick(click))
	   	  {
	   	  	 GoFront(navigate,4);
	   	  	 ChangeLayout_R(4,R1,R2,R3,R4,R5,R6);
		 	 ChangeLayout_B(4,B1,B2,B3,B4,B5,B6);
		 	 ChangeLayout_T(4,T1,T2,T3,T4,T5,T6);

	   	  }

	   	   else if(B3.checkclick(click))
	   	  {
	   	  	 GoFront(navigate,5);
	   	  	 ChangeLayout_R(5,R1,R2,R3,R4,R5,R6);
		 	 ChangeLayout_B(5,B1,B2,B3,B4,B5,B6);
		 	 ChangeLayout_T(5,T1,T2,T3,T4,T5,T6);

	   	  }

	   	   else if(B4.checkclick(click))
	   	  {
	   	  	 GoFront(navigate,6);
	   	  	 ChangeLayout_R(6,R1,R2,R3,R4,R5,R6);
		 	 ChangeLayout_B(6,B1,B2,B3,B4,B5,B6);
		 	 ChangeLayout_T(6,T1,T2,T3,T4,T5,T6);

	   	  }

	   	   else if(B5.checkclick(click))
	   	  {
	   	  	 GoFront(navigate,7);
	   	  	 ChangeLayout_R(7,R1,R2,R3,R4,R5,R6);
		 	 ChangeLayout_B(7,B1,B2,B3,B4,B5,B6);
		 	 ChangeLayout_T(7,T1,T2,T3,T4,T5,T6);

	   	  }

	   } 

	    else if(navigate.page_no()==2)
	   {

	   	  if(B1.checkclick(click))
	   	  {
	   	  	 GoFront(navigate,8);
	   	  	 ChangeLayout_R(8,R1,R2,R3,R4,R5,R6);
		 	 ChangeLayout_B(8,B1,B2,B3,B4,B5,B6);
		 	 ChangeLayout_T(8,T1,T2,T3,T4,T5,T6);
	   	  }

	   	  else if(B2.checkclick(click))
	   	  {
	   	  	 GoFront(navigate,9);
	   	  	 ChangeLayout_R(9,R1,R2,R3,R4,R5,R6);
		 	 ChangeLayout_B(9,B1,B2,B3,B4,B5,B6);
		 	 ChangeLayout_T(9,T1,T2,T3,T4,T5,T6);

	   	  }
         
          else if(B3.checkclick(click))
	   	  {
	   	  	 GoFront(navigate,10);
	   	  	 ChangeLayout_R(10,R1,R2,R3,R4,R5,R6);
		 	 ChangeLayout_B(10,B1,B2,B3,B4,B5,B6);
		 	 ChangeLayout_T(10,T1,T2,T3,T4,T5,T6);

	   	  }
          
          else if(B4.checkclick(click))
	   	  {
	   	  	 GoFront(navigate,11);
	   	  	 ChangeLayout_R(11,R1,R2,R3,R4,R5,R6);
		 	 ChangeLayout_B(11,B1,B2,B3,B4,B5,B6);
		 	 ChangeLayout_T(11,T1,T2,T3,T4,T5,T6);

	   	  }

	   	   else if(B5.checkclick(click))
	   	  {
	   	  	 GoFront(navigate,12);
	   	  	 ChangeLayout_R(12,R1,R2,R3,R4,R5,R6);
		 	 ChangeLayout_B(12,B1,B2,B3,B4,B5,B6);
		 	 ChangeLayout_T(12,T1,T2,T3,T4,T5,T6);

	   	  }

	   }

		 if(Bback.checkclick(click))
		 {
		 	GoBack(navigate);
		 	ChangeLayout_R(navigate.page_no(),R1,R2,R3,R4,R5,R6);
		 	ChangeLayout_B(navigate.page_no(),B1,B2,B3,B4,B5,B6);
		 	ChangeLayout_T(navigate.page_no(),T1,T2,T3,T4,T5,T6);
		 }
		
		 
	
     };
	
	return 0;
}


