#include <simplecpp>
#include <iostream>
#include <cstdio>
#include <page_layout.h>
#include <fparser.hh>
#include <integrator.h>
#include <double_integrator.h>
#include <2D_3D_numerical.h>
#include <Max_Min.h>


const float canwid = 690;

double integratormain(char[],double,double);

Button::Button(int x,int y,int l,int b)
{
	centrex=x;
	centrey=y;
	width=l;
	height=b;
}

int Button::checkclick(int temp)
{
 
    if(centrex-width/2<=temp/65536 && centrex+width/2>=temp/65536 && centrey%65536-height/2<=temp%65536 && centrey%65536+height/2>=temp%65536 )
    {
    	return 1;
    }

    return 0;
}

void Button::Reset(int x,int y,int l,int b)
{
	centrex=x;
	centrey=y;
	width=l;
	height=b;

	return;
}


int Navigator::push(int elem)
{
	if(top<4)
	{
        queue[++top]=elem;
        return top;
	} 

	else 
	{
		top=0;
		return 0;
	}
}

int Navigator::pop()
{
     if(top==0)  return 0;
     
     else
     {
     	top--;
     	return 1;
     }
}

int Navigator::page_no()
{
	return queue[top];
}

Navigator::Navigator()
{
	top=0;
	for(int i=0;i<20;i++)
		queue[i]=0;
}

void TextBox(char* string)
{
   Text t1(0,0,"");

   XEvent e1[60];//array for events
   bool a,b;
   int k=0;
  

   for(int i=0;i<58 && k<58;)
   {
   
     nextEvent(e1[i]);
     wait(0.05);
     b=mouseButtonPressEvent(e1[i]);
     a=keyPressEvent(e1[i]);//checking if the event is key press or not
    
     if(b) ;
    
     else if(a)
     { 
        char key=charFromEvent(e1[i]);     //getting char from key i.e ascii
        cout<<key;
        
        if(key==(13)){break;}

        else if(key==8)
        {
            string[--k]='\0';
        }

        else
        {        
          string[k]=key;
          string[++k]='\0';
          cout<<string;
         } 
         
         t1.reset(canwid/2+100,canwid/2,string);
               
      }
    
      else 
      { 
        if(i>1) i--; 
      }  
      
   
 }



}



void ChangeLayout_B(int pageno,Button& B1,Button& B2,Button& B3,Button& B4,Button& B5,Button& B6)
{
	   switch(pageno)
	   {
	   	  case 0 :  B1.Reset(canwid/2+100,canwid/2-150,150,100);   
    				B2.Reset(canwid/2+100,canwid/2+150,150,100);
    				B3.Reset(0,0,0,0);
    				B4.Reset(0,0,0,0);
    				B5.Reset(0,0,0,0);
                    B6.Reset(0,0,0,0);            
   					
   					break;

   		  case 1 :  B1.Reset(canwid/2+100,(canwid-60)/6,150,canwid/12);   
            B2.Reset(canwid/2+100,2*(canwid-60)/6,150,canwid/12);
            B3.Reset(canwid/2+100,3*(canwid-60)/6,150,canwid/12);
            B4.Reset(0,0,0,0);
            B5.Reset(0,0,0,0);
            B6.Reset(0,0,0,0);
            break;


    	  case 2 :  B1.Reset(canwid/2+100,2*(canwid-60)/6,150,canwid/12);   
            B2.Reset(0,0,0,0);
            B3.Reset(canwid/2+100,3*(canwid-60)/6,150,canwid/12);
            B4.Reset(canwid/2+100,4*(canwid-60)/6,150,canwid/12);
            B5.Reset(canwid/2+100,5*(canwid-60)/6,150,canwid/12);
            B6.Reset(0,0,0,0);
    				break;

          case 3 :  B1.Reset(0,0,0,0);
                    B2.Reset(0,0,0,0);
                    B3.Reset(0,0,0,0);
                    B4.Reset(0,0,0,0);
                    B5.Reset(0,0,0,0);
                    B6.Reset(0,0,0,0);
                    break;

          case 4 :  B1.Reset(0,0,0,0);
                    B2.Reset(0,0,0,0);
                    B3.Reset(0,0,0,0);
                    B4.Reset(0,0,0,0);
                    B5.Reset(0,0,0,0);
                    B6.Reset(0,0,0,0);
                    break;
                    
          case 5 :  B1.Reset(0,0,0,0);
                    B2.Reset(0,0,0,0);
                    B3.Reset(0,0,0,0);
                    B4.Reset(0,0,0,0);
                    B5.Reset(0,0,0,0);
                    B6.Reset(0,0,0,0);
                    break;   

        case 6 :  B1.Reset(0,0,0,0);
                    B2.Reset(0,0,0,0);
                    B3.Reset(0,0,0,0);
                    B4.Reset(0,0,0,0);
                    B5.Reset(0,0,0,0);
                    B6.Reset(0,0,0,0);
                    break;  

        case 7 :  B1.Reset(0,0,0,0);
                    B2.Reset(0,0,0,0);
                    B3.Reset(0,0,0,0);
                    B4.Reset(0,0,0,0);
                    B5.Reset(0,0,0,0);
                    B6.Reset(0,0,0,0);
                    break;  
                           
          case 8 : B1.Reset(0,0,0,0);
                    B2.Reset(0,0,0,0);
                    B3.Reset(0,0,0,0);
                    B4.Reset(0,0,0,0);
                    B5.Reset(0,0,0,0);
                    B6.Reset(0,0,0,0);
                    break;

           case 9 : B1.Reset(0,0,0,0);
                    B2.Reset(0,0,0,0);
                    B3.Reset(0,0,0,0);
                    B4.Reset(0,0,0,0);
                    B5.Reset(0,0,0,0);
                    B6.Reset(0,0,0,0);
                    break;

          case 10 : B1.Reset(0,0,0,0);
                    B2.Reset(0,0,0,0);
                    B3.Reset(0,0,0,0);
                    B4.Reset(0,0,0,0);
                    B5.Reset(0,0,0,0);
                    B6.Reset(0,0,0,0);
                    break;

          case 11 : B1.Reset(0,0,0,0);
                    B2.Reset(0,0,0,0);
                    B3.Reset(0,0,0,0);
                    B4.Reset(0,0,0,0);
                    B5.Reset(0,0,0,0);
                    B6.Reset(0,0,0,0);
                    break;

          case 12 : B1.Reset(0,0,0,0);
                    B2.Reset(0,0,0,0);
                    B3.Reset(0,0,0,0);
                    B4.Reset(0,0,0,0);
                    B5.Reset(0,0,0,0);
                    B6.Reset(0,0,0,0);
                    break;

        
	   }
}

void ChangeLayout_R(int pageno,Rectangle& R1,Rectangle& R2,Rectangle& R3,Rectangle& R4,Rectangle& R5,Rectangle& R6)
{
	   switch(pageno)
	   {
	   	  case 0 :  R1.reset(canwid/2+100,canwid/2-150,150,100);
    				R2.reset(canwid/2+100,canwid/2+150,150,100);
    				R3.reset(0,0,0,0);
    				R4.reset(0,0,0,0);
    				R5.reset(0,0,0,0);
                    R6.reset(0,0,0,0);
                    R1.setColor(COLOR("Maroon"));
    				R2.setColor(COLOR("Maroon"));
    				R1.setFill();
    				R2.setFill();
   					break;

   		  case 1 :  R1.reset(canwid/2+100,(canwid-60)/6,150,canwid/12);   
            R2.reset(canwid/2+100,2*(canwid-60)/6,150,canwid/12);
            R3.reset(canwid/2+100,3*(canwid-60)/6,150,canwid/12);
            R4.reset(0,0,0,0);
            R5.reset(0,0,0,0);
            R6.reset(0,0,0,0);

    				R1.setColor(COLOR("Maroon"));
    				R2.setColor(COLOR("Maroon"));
    				R3.setColor(COLOR("Maroon"));
    				R4.setColor(COLOR("Maroon"));
    				R5.setColor(COLOR("Maroon"));
    		

    				R1.setFill();
    				R2.setFill();
    				R3.setFill();
    				R4.setFill();
    				R5.setFill();
    		
    				
    				break;

    	  case 2 :  R1.reset(canwid/2+100,2*(canwid-60)/6,150,canwid/12);   
            R2.reset(canwid/2+100,2*(canwid-60)/6,150,canwid/12);
            R3.reset(canwid/2+100,3*(canwid-60)/6,150,canwid/12);
            R4.reset(canwid/2+100,4*(canwid-60)/6,150,canwid/12);
            R5.reset(canwid/2+100,5*(canwid-60)/6,150,canwid/12);
            R6.reset(0,0,0,0);

    				R1.setColor(COLOR("Maroon"));
    				R2.setColor(COLOR("Maroon"));
    				R3.setColor(COLOR("Maroon"));
    				R4.setColor(COLOR("Maroon"));
    				R5.setColor(COLOR("Maroon"));
            R6.setColor(COLOR("Maroon"));

    				R1.setFill();
    				R2.setFill();
    				R3.setFill();
    				R4.setFill();
    				R5.setFill();
            R6.setFill();

    				break;

          case 3 :  R1.reset(canwid/2+100,canwid/2,300,300); 
                    R2.reset(0,0,0,0);
                    R3.reset(0,0,0,0);
                    R4.reset(0,0,0,0);
                    R5.reset(0,0,0,0);
                    R6.reset(0,0,0,0);

                    R1.setColor(COLOR("Maroon"));
                    R1.setFill(false);
                    break;

          case 4 :  R1.reset(canwid/2+100,canwid/2,300,300); 
                    R2.reset(0,0,0,0);
                    R3.reset(0,0,0,0);
                    R4.reset(0,0,0,0);
                    R5.reset(0,0,0,0);
                    R6.reset(0,0,0,0);

                    R1.setColor(COLOR("Maroon"));
                    R1.setFill(false);
                    break;

          case 5 :  R1.reset(canwid/2+100,canwid/2,300,300); 
                    R2.reset(0,0,0,0);
                    R3.reset(0,0,0,0);
                    R4.reset(0,0,0,0);
                    R5.reset(0,0,0,0);
                    R6.reset(0,0,0,0);

                    R1.setColor(COLOR("Maroon"));
                    R1.setFill(false);
                    break;

         case 6 :  R1.reset(canwid/2+100,canwid/2,300,300); 
                    R2.reset(0,0,0,0);
                    R3.reset(0,0,0,0);
                    R4.reset(0,0,0,0);
                    R5.reset(0,0,0,0);
                    R6.reset(0,0,0,0);

                    R1.setColor(COLOR("Maroon"));
                    R1.setFill(false);
                    break;
                    
         case 7 :  R1.reset(canwid/2+100,canwid/2,300,300); 
                    R2.reset(0,0,0,0);
                    R3.reset(0,0,0,0);
                    R4.reset(0,0,0,0);
                    R5.reset(0,0,0,0);
                    R6.reset(0,0,0,0);

                    R1.setColor(COLOR("Maroon"));
                    R1.setFill(false);
                    break;        

          case 8 :  R1.reset(canwid/2+100,canwid/2,300,300); 
                    R2.reset(0,0,0,0);
                    R3.reset(0,0,0,0);
                    R4.reset(0,0,0,0);
                    R5.reset(0,0,0,0);
                    R6.reset(0,0,0,0);

                    R1.setColor(COLOR("Maroon"));
                    R1.setFill(false);
                    break;

          case 9 :  R1.reset(canwid/2+100,canwid/2,300,300); 
                    R2.reset(0,0,0,0);
                    R3.reset(0,0,0,0);
                    R4.reset(0,0,0,0);
                    R5.reset(0,0,0,0);
                    R6.reset(0,0,0,0);

                    R1.setColor(COLOR("Maroon"));
                    R1.setFill(false);
                    break;

         case 10 :  R1.reset(canwid/2+100,canwid/2,300,300); 
                    R2.reset(0,0,0,0);
                    R3.reset(0,0,0,0);
                    R4.reset(0,0,0,0);
                    R5.reset(0,0,0,0);
                    R6.reset(0,0,0,0);

                    R1.setColor(COLOR("Maroon"));
                    R1.setFill(false);
                    break;

         case 11 :  R1.reset(canwid/2+100,canwid/2,300,300); 
                    R2.reset(0,0,0,0);
                    R3.reset(0,0,0,0);
                    R4.reset(0,0,0,0);
                    R5.reset(0,0,0,0);
                    R6.reset(0,0,0,0);

                    R1.setColor(COLOR("Maroon"));
                    R1.setFill(false);
                    break;

         case 12 :  R1.reset(canwid/2+100,canwid/2,300,300); 
                    R2.reset(0,0,0,0);
                    R3.reset(0,0,0,0);
                    R4.reset(0,0,0,0);
                    R5.reset(0,0,0,0);
                    R6.reset(0,0,0,0);

                    R1.setColor(COLOR("Maroon"));
                    R1.setFill(false);
                    break;
}

}

void ChangeLayout_T(int pageno,Text& R1,Text& R2,Text& R3,Text& R4,Text& R5,Text& R6)
{

    char function[60]; 
    char* result;  //Required for entering the function value
    float area;
     float low_limit,high_limit; 
     float x,y;  
     char ch;
     double res;
     double* root=new double[5];
     float num;

	  switch(pageno)
	  {
	   	  case 0 :  R1.reset(canwid/2+100,canwid/2-150,"Two-Dimensional");   
    				R2.reset(canwid/2+100,canwid/2+150,"Three-Dimensional");
    				R3.hide();
    				R4.hide();
    				R5.hide();
                    R6.hide();            
   					
   					break;

   		  case 1 :  R1.reset(canwid/2+100,(canwid-60)/6,"Area under a curve");   
            R2.reset(canwid/2+100,2*(canwid-60)/6,"Calculate Derivative");
            R3.reset(canwid/2+100,3*(canwid-60)/6,"Tangents and Normals");
            R4.hide();
            R5.hide();
            R6.hide();
    				break;

    	  case 2 :  R1.reset(canwid/2+100,2*(canwid-60)/6,"Double integral");   
            R2.reset(0,0,0);
            R3.reset(canwid/2+100,3*(canwid-60)/6,"Gradient at a point");
            R4.reset(canwid/2+100,4*(canwid-60)/6,"Directional Derivative");
            R5.reset(canwid/2+100,5*(canwid-60)/6,"Tangents and Normals");
            R6.hide();
    				
    				break;

          case 3 :  R2.hide();
                    R3.hide();
                    R4.hide();
                    R5.hide();
                    R6.hide();
                    R1.hide();
                    
                    
                      

                    R1.reset(canwid/2+50,canwid/2-100,"Enter lower limit");
                    TextBox(function); 
                    sscanf(function,"%f",&low_limit);     
                    R1.reset(canwid/2+50,canwid/2-100,"Enter upper limit");
                    TextBox(function); 
                    sscanf(function,"%f",&high_limit);   
                    R1.reset(canwid/2+50,canwid/2-100,"Enter your function ");
                    TextBox(function);  
               
                    area = integratormain(function,low_limit,high_limit);
                    R1.reset(canwid/2+50,canwid/2-100,"Your area is : ");
                    R2.reset(canwid/2+100,canwid/2,area);
                    getClick();
            
                    break;

         case 4 :   R2.hide();
                    R3.hide();
                    R4.hide();
                    R5.hide();
                    R6.hide();
                    R1.hide();               

                    R1.reset(canwid/2+50,canwid/2-100,"Enter x");
                    TextBox(function); 
                    sscanf(function,"%f",&x);         
                    R1.reset(canwid/2+50,canwid/2-100,"Enter your function ");
                    TextBox(function);  
                    result = D2(function,x,'d');
                    R1.reset(canwid/2+50,canwid/2-100,"Required Derivative is : ");
                    R2.reset(canwid/2+100,canwid/2,result);
                    getClick();
            
                    break;

         case 5 :   R2.hide();
                    R3.hide();
                    R4.hide();
                    R5.hide();
                    R6.hide();
                    R1.hide();               

                    R1.reset(canwid/2+50,canwid/2-100,"Enter x");
                    TextBox(function); 
                    sscanf(function,"%f",&x);   
                     R1.reset(canwid/2+50,canwid/2-100,"Enter t for tangent / n for normal");
                    TextBox(function); 
                    sscanf(function,"%1s",&ch); 
                       R1.reset(canwid/2+50,canwid/2-100,"Enter width of the plot (5is ideal)");
                    TextBox(function); 
                    sscanf(function,"%f",&num);     
                    R1.reset(canwid/2+50,canwid/2-100,"Enter your function ");
                    TextBox(function);  




                    result = D2(function,x,ch);
                  
                    cout<<function<<" ";
                    if(ch=='t')
                    {
                    	R1.reset(canwid/2+50,canwid/2-100,"Required Tangent is : ");
                        //tangent(function,x,num);
                    }

                    else if(ch=='n')
                    {
                    	R1.reset(canwid/2+50,canwid/2-100,"Required Normal is : ");
                       // normal(function,x,num);
                    }	
                    R2.reset(canwid/2+100,canwid/2,result);
                    fflush(stdout);
                    getClick();
            
                    break;

          

         case 7 :   R2.hide();
                    R3.hide();
                    R4.hide();
                    R5.hide();
                    R6.hide();
                    R1.hide();               
                     R1.reset(canwid/2+50,canwid/2-100,"Enter lower limit");
                    TextBox(function); 
                    sscanf(function,"%f",low_limit); 
                    R1.reset(canwid/2+50,canwid/2-100,"Enter higher limit");
                    TextBox(function); 
                    sscanf(function,"%f",high_limit); 
                     R1.reset(canwid/2+50,canwid/2-100,"Enter number of roots");
                    TextBox(function);
                    sscanf(function,"%f",num); 
                    R1.reset(canwid/2+50,canwid/2-100,"Enter your function ");
                    TextBox(function);
                    root = dividensolve(function,low_limit,high_limit,5);
                    
                    fflush(stdout);
                    getClick();
            
                    break;

         case 8 :   R2.hide();
                    R3.hide();
                    R4.hide();
                    R5.hide();
                    R6.hide();
                    R1.hide();
                
                    float low_limitx,high_limitx,low_limity,high_limity;    

                    R1.reset(canwid/2+50,canwid/2-100,"Enter lower limit of x");
                    TextBox(function); 
                    sscanf(function,"%f",&low_limitx);     
                    R1.reset(canwid/2+50,canwid/2-100,"Enter upper limit of x");
                    TextBox(function); 
                    sscanf(function,"%f",&high_limitx);   
                     R1.reset(canwid/2+50,canwid/2-100,"Enter lower limit of y");
                    TextBox(function); 
                    sscanf(function,"%f",&low_limity);     
                    R1.reset(canwid/2+50,canwid/2-100,"Enter upper limit of y");
                    TextBox(function); 
                    sscanf(function,"%f",&high_limity);   
                    R1.reset(canwid/2+50,canwid/2-100,"Enter your function ");
                    TextBox(function);  
               
                    area = doubleintegratormain(function,low_limity,high_limity,low_limitx,high_limitx);
                    R1.reset(canwid/2+50,canwid/2-100,"Your area is : ");
                    R2.reset(canwid/2+100,canwid/2,area);
                    getClick();
            
                    break;

         case 9 :  R2.hide();
                    R3.hide();
                    R4.hide();
                    R5.hide();
                    R6.hide();
                    R1.hide();                     
                    R1.reset(canwid/2+50,canwid/2-100,"Enter your function ");
                    TextBox(function);
                    D3(function);
                    R1.reset(canwid/2+50,canwid/2-100,"Required Gradient : ");
                    R2.reset(canwid/2+100,canwid/2,function);
                    getClick();
            
                    break;

         case 10 :  R2.hide();
                    R3.hide();
                    R4.hide();
                    R5.hide();
                    R6.hide();
                    R1.hide();
                
                    float x,y;    

                    R1.reset(canwid/2+50,canwid/2-100,"Enter x");
                    TextBox(function); 
                    sscanf(function,"%f",&x);                    
                     R1.reset(canwid/2+50,canwid/2-100,"Enter y");
                    TextBox(function); 
                    sscanf(function,"%f",&y);                      
                    R1.reset(canwid/2+50,canwid/2-100,"Enter your function ");
                    TextBox(function);
                    result = D3(function,x,y,'g');
                    R1.reset(canwid/2+50,canwid/2-100,"Required Gradient : ");
                    R2.reset(canwid/2+100,canwid/2,result);
                    getClick();
            
                    break;

   

         case 11 :  R2.hide();
                    R3.hide();
                    R4.hide();
                    R5.hide();
                    R6.hide();
                    R1.hide();
                
                    float d1,d2;    

                    R1.reset(canwid/2+50,canwid/2-100,"Enter x");
                    TextBox(function); 
                    sscanf(function,"%f",&x);                    
                     R1.reset(canwid/2+50,canwid/2-100,"Enter y");
                    TextBox(function); 
                    sscanf(function,"%f",&y);                      
                    R1.reset(canwid/2+50,canwid/2-100,"Enter xcomponent of the direction");
                    TextBox(function);
                    sscanf(function,"%f",&d1); 
                    R1.reset(canwid/2+50,canwid/2-100,"Enter ycomponent of the direction");
                    TextBox(function);
                    sscanf(function,"%f",&d2); 
                    R1.reset(canwid/2+50,canwid/2-100,"Enter function");
                    TextBox(function);
                  
                    result = D3(function,x,y,d1,d2);
               
                    R1.reset(canwid/2+50,canwid/2-100,"Required Directional Derivative : ");
                    R2.reset(canwid/2+100,canwid/2,result);
               
                    getClick();
            
                    break;
    
         case 12 :   R2.hide();
                    R3.hide();
                    R4.hide();
                    R5.hide();
                    R6.hide();
                    R1.hide();               
                  
                    R1.reset(canwid/2+50,canwid/2-100,"Enter x");
                    TextBox(function); 
                    sscanf(function,"%f",&x);   
                    R1.reset(canwid/2+50,canwid/2-100,"Enter y");
                    TextBox(function); 
                    sscanf(function,"%f",&y);         
                    R1.reset(canwid/2+50,canwid/2-100,"Enter t for tangent / n for normal");
                    TextBox(function); 
                    sscanf(function,"%1s",&ch);
                    R1.reset(canwid/2+50,canwid/2-100,"Enter width of the plot (5is ideal)");
                    TextBox(function); 
                    sscanf(function,"%f",&num);
                    R1.reset(canwid/2+50,canwid/2-100,"Enter your function ");
                    TextBox(function);  
                    
                    result=D3(function,x,y,ch);
                    if(ch=='t')
                    {
                    	R1.reset(canwid/2+50,canwid/2-100,"Required Tangent is : ");
                        //stangent(function,x,y,num);
                    }

                    else if(ch=='n')
                    {
                    	R1.reset(canwid/2+50,canwid/2-100,"Required Normal is : ");
                    }	
                    R2.reset(canwid/2+100,canwid/2,result);
                    fflush(stdout);
                    getClick();
            
                    break;

        }
 }


void GoFront(Navigator& navigate,int pageno)
{
	navigate.push(pageno);
	
}

void GoBack(Navigator& navigate)
{
	navigate.pop();	
}



