/*#include <cstdlib>
#include <cstring>
#include <fstream>
#include <derivative.h>
#include <fparser.hh>

using namespace std;

void plot(string,int);//works
void tangent(string,double,double);// working
void stangent(string,double,double,double);//not working
double val(string,double);//working
double sval(string,double,double);//working
double* dividensolve(string,double,double,int);//working
float root(string,double,int);//working
double slope(string,double);//working
double xslope(string,double,double);//working
double yslope(string,double,double);//working
string convert(double);//working
double minfn(string,double,double);// working
double maxfn(string,double,double);// working

void plot(string c,int n)
{
if (n==2)
{
    string a="\"cmd.exe /c gnuplot -e \"set terminal png ;set output 'plot2.png'; plot ";
    string b="\"";
    string d=a+c+b;
 //   cout<<d<<endl;

    system(d.c_str() );
}
if (n==3)
{

    string a="\"cmd.exe /c gnuplot -e \"set terminal png ;set output 'plot2.png'; splot ";
    string b="\"";
    string d=a+c+b;
   // cout<<d<<endl;

    system(d.c_str());
}
}


void tangent(string c,double x,double width)
{
    double low=x-width;
    double high=x+width;

    string tang="(x-";

    string tang2=convert(x);

    string tang3=")*";

    string tang4=convert(slope(c,x));

    string tang5="+";

    string tang6=convert(val(c,x));

    string tangent=tang+tang2+tang3+tang4+tang5+tang6;

    double ylow=minfn(c,low,high);
    double yhigh=maxfn(c,low,high);

    string multi="set terminal png;set output 'plot1.png';set multiplot;set xrange[";
    string mlt1=convert(low);
    string mlt2=":";
    string mlt3=convert(high);
    string mlt4="];set yrange[";
    string mlt5=convert(yhigh);
    string mlt6=":";
    string mlt7=convert(ylow);
    string mlt8="];plot ";
    string multi2="; set xrange[";
    string multi3=" lt rgb 'green' \"";
    string prompt="\"cmd.exe /c gnuplot -e \"";

    string both=prompt+multi+mlt1+mlt2+mlt3+mlt4+mlt5+mlt6+mlt7+mlt8+c+multi2+mlt1+mlt2+mlt3+mlt4+mlt5+mlt6+mlt7+mlt8+tangent+multi3;

    system(both.c_str());

    return;


}
void stangent(string c,double x,double y,double width=5)
{
    double xlow=x-width;
    double xhigh=x+width;
    double ylow=y-width;
    double yhigh=y+width;

    string tang="(x-";

    string tang2=convert(x);

    string tang3=")*";

    string tang4=convert(xslope(c,x,y));

    string tang5="+";

    string tang6="(y-";

    string tang7=convert(y);

    string tang8=")*";

    string tang9=convert(yslope(c,x,y));

    string tang10="+";

    string tang11=convert(sval(c,x,y));

    string tangent=tang+tang2+tang3+tang4+tang5+tang6+tang7+tang8+tang9+tang10+tang11;

    double l=sval(c,x,y)-width;
    double h=sval(c,x,y)+width;

    string multi="set terminal png;set output 'plot1.png';set multiplot;set xrange[";
    string mlt1=convert(xlow);
    string mlt2=":";
    string mlt3=convert(xhigh);
    string mlt4="];set yrange[";
    string mlt5=convert(ylow);
    string mlt6=":";
    string mlt7=convert(yhigh);
    string mlt8="];set zrange[";
    string mlt9=convert(l);
    string mlt10=":";
    string mlt11=convert(h);
    string mlt12="];splot ";
    string multi2="; set xrange[";
    string multi3=" lt rgb 'green'\"";
    string prompt="\"cmd.exe /c gnuplot -e \"";

    string both=prompt+multi+mlt1+mlt2+mlt3+mlt4+mlt5+mlt6+mlt7+mlt8+mlt9+mlt10+mlt11+mlt12+c+multi2+mlt1+mlt2+mlt3+mlt4+mlt5+mlt6+mlt7+mlt8+mlt9+mlt10+mlt11+mlt12+tangent+multi3;

    system(both.c_str());

    return;


}
double val(string c,double x)
{
    FunctionParser fp1;
    fp1.Parse(c,"x");
    double variables[1]={x};
    double result = fp1.Eval(variables);
    return result;
}
double sval(string c,double x,double y)
{
    FunctionParser fp1;
    fp1.Parse(c,"x,y");
    double variables[2]={x,y};
    double result = fp1.Eval(variables);
    return result;
}


double* dividensolve(string func,double low,double high, int n)
{int i;
    double* x=new double[n];
    for (i=1;i<=n;i++)
    {
        if (val(func,root(func,(low+(high-low)*(i-1)/n+(low+(high-low)*i/n))/2,150))<0.00001)
        {
            x[i-1]=root(func,(low+(high-low)*(i-1)/n+(low+(high-low)*i/n))/2,150);
        }
    }
    int j=0,ct=0,k=0;
    double* y=new double[n];
    for (i=0;i<n;i++)
    {
        ct=0;
        for (j=0;j<i;j++)
        {
            if (x[i]==y[j]){ct++;break;}
        }
        if (ct==0){y[k]=x[i];k++;}
    }
    return y;
}
float root(string func,double m,int n)
{
    if  (n>0)
    {
    //cout<<m;
    m=root(func,m-(val(func,m))/slope(func,m),n-1);
    }
    float cheat=m;
    return cheat;
}
double slope(string c,double x)
{
   const char* str;
    str=c.c_str();
    return val(deriv_fn(str,"x"),x);
}
double xslope(string c,double x,double y)
{
    const char* str;
    str=c.c_str();
    return sval(deriv_fn(str,"x"),x,y);
}
double yslope(string c,double x,double y)
{
    const char* str;
    str=c.c_str();
    return sval(deriv_fn(str,"y"),x,y);
}
string convert(double n)
{
    char arr[20];
    sprintf(arr,"%f",n);
    string answer(arr);
    return answer;
}
double minfn(string c ,double low,double high)
{
    int i;
    const char* str;
    str=c.c_str();
    double minf[50]={0};
    double* x=new double[50];
    string dc(deriv_fn(str,"x"));

    x=dividensolve(dc,low,high,50);

    //for (i=0;i<50;i++){cout<<x[i];}
    for (i=0;i<50;i++)
    {if ((x[i]<=high) && (x[i]>=low))
    {

           minf[i]=x[i];
    }
    }
    delete[] x;
    double mnf=minf[0];
    for (i=0;i<50;i++)
    {
        if(minf[i]<mnf)
        {
            mnf=minf[i];
        }
    }

    if(val(c,low)<mnf){mnf=val(c,low);}

    if(val(c,high)<mnf){mnf=val(c,high);}
    return val(c,mnf);
}

double maxfn(string c ,double low,double high)
{
    int i;
    const char* str;
    str=c.c_str();
    double maxf[50]={0};
    double* x=new double[50];
    string dc(deriv_fn(str,"x"));

    x=dividensolve(dc,low,high,50);

    //for (i=0;i<50;i++){cout<<x[i];}
    for (i=0;i<50;i++)
    {if ((x[i]<=high) && (x[i]>=low))
    {

           maxf[i]=x[i];
    }
    }
    delete[] x;
    double mxf=maxf[0];
    for (i=0;i<50;i++)
    {
        if(maxf[i]>mxf)
        {
            mxf=maxf[i];
        }
    }

    if(val(c,low)>mxf){mxf=val(c,low);}

    if(val(c,high)>mxf){mxf=val(c,high);}
    return val(c,mxf);
}
*/
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <fstream>
#include <derivative.h>
#include <fparser.hh>


using namespace std;

void plot(string,int);//works
void tangent(string,double,double);// working
void normal(string,double,double);
void stangent(string,double,double,double);//not working
double val(string,double);//working
double sval(string,double,double);//working
double* dividensolve(string,double,double,int);//working
float root(string,double,int);//working
double slope(string,double);//working
double xslope(string,double,double);//working
double yslope(string,double,double);//working
string convert(double);//working
//double minfn(string,double,double);// working
//double maxfn(string,double,double);// working




void plot(string c,int n)
{
if (n==2)
{
    string a="\"cmd.exe /c gnuplot -e \"set terminal png ;set output 'plot2.png'; plot ";
    string b="\"";
    string d=a+c+b;
    cout<<d;
 //   cout<<d<<endl;

    system(d.c_str() );
    }
if (n==3)
{

    string a="\"cmd.exe /c gnuplot -e \"set terminal png ;set output 'plot2.png'; splot ";
    string b="\"";
    string d=a+c+b;
   // cout<<d<<endl;

    system(d.c_str());
}
}


void tangent(string c,double x,double width)
{
    double low=x-width;
    double high=x+width;

    string tang="(x-";

    string tang2=convert(x);

    string tang3=")*";

    string tang4=convert(slope(c,x));

    string tang5="+";

    string tang6=convert(val(c,x));

    string tangent=tang+tang2+tang3+tang4+tang5+tang6;

    double ylow=val(c,x)-width;
    double yhigh=val(c,x)+width;

    string multi="set terminal png;set output 'plot1.png';set multiplot;set xrange[";
    string mlt1=convert(low);
    string mlt2=":";
    string mlt3=convert(high);
    string mlt4="];set yrange[";
    string mlt5=convert(ylow);
    string mlt6=":";
    string mlt7=convert(yhigh);
    string mlt8="];plot ";
    string multi2="; set xrange[";
    string multi3=" lt rgb 'green' \"";
    string prompt="\"cmd.exe /c gnuplot -e \"";

    string both=prompt+multi+mlt1+mlt2+mlt3+mlt4+mlt5+mlt6+mlt7+mlt8+c+multi2+mlt1+mlt2+mlt3+mlt4+mlt5+mlt6+mlt7+mlt8+tangent+multi3;

    system(both.c_str());

    return;


}
void stangent(string c,double x,double y,double width=5)
{
    double xlow=x-width;
    double xhigh=x+width;
    double ylow=y-width;
    double yhigh=y+width;

    string tang="(x-";

    string tang2=convert(x);

    string tang3=")*";

    string tang4=convert(xslope(c,x,y));

    string tang5="+";

    string tang6="(y-";

    string tang7=convert(y);

    string tang8=")*";

    string tang9=convert(yslope(c,x,y));

    string tang10="+";

    string tang11=convert(sval(c,x,y));

    string tangent=tang+tang2+tang3+tang4+tang5+tang6+tang7+tang8+tang9+tang10+tang11;

    double l=sval(c,x,y)-width;
    double h=sval(c,x,y)+width;

    string multi="set terminal png;set output 'plot1.png';set multiplot;set xrange[";
    string mlt1=convert(xlow);
    string mlt2=":";
    string mlt3=convert(xhigh);
    string mlt4="];set yrange[";
    string mlt5=convert(ylow);
    string mlt6=":";
    string mlt7=convert(yhigh);
    string mlt8="];set zrange[";
    string mlt9=convert(l);
    string mlt10=":";
    string mlt11=convert(h);
    string mlt12="];splot ";
    string multi2="; set xrange[";
    string multi3=" lt rgb 'green'\"";
    string prompt="\"cmd.exe /c gnuplot -e \"";

    string both=prompt+multi+mlt1+mlt2+mlt3+mlt4+mlt5+mlt6+mlt7+mlt8+mlt9+mlt10+mlt11+mlt12+c+multi2+mlt1+mlt2+mlt3+mlt4+mlt5+mlt6+mlt7+mlt8+mlt9+mlt10+mlt11+mlt12+tangent+multi3;

    system(both.c_str());

    return;


}
double val(string c,double x)
{
    FunctionParser fp1;
    fp1.Parse(c,"x");
    double variables[1]={x};
    double result = fp1.Eval(variables);
    return result;
}
double sval(string c,double x,double y)
{
    FunctionParser fp1;
    fp1.Parse(c,"x,y");
    double variables[2]={x,y};
    double result = fp1.Eval(variables);
    return result;
}


double* dividensolve(string func,double low,double high, int n)
{int i;
    double* x=new double[n];
    for (i=1;i<=n;i++)
    {
        if (val(func,root(func,(low+(high-low)*(i-1)/n+(low+(high-low)*i/n))/2,150))<0.00001 && val(func,root(func,(low+(high-low)*(i-1)/n+(low+(high-low)*i/n))/2,150))>-0.00001)
        {
            x[i-1]=root(func,(low+(high-low)*(i-1)/n+(low+(high-low)*i/n))/2,150);
        }
    }
    int j=0,ct=0,k=0;
    double* y=new double[n];
    for (i=0;i<n;i++)
    {
        ct=0;
        for (j=0;j<i;j++)
        {
            if (x[i]==y[j]){ct++;break;}
        }
        if (ct==0){y[k]=x[i];k++;}
    }
    return y;
}
float root(string func,double m,int n)
{
    double d;
    if  (n>0)
    {
    //cout<<m;
    if(slope(func,m)<0.000001 && slope(func,m)>-0.00001)
    {
        d=1;
    }
    else {d=slope(func,m);}
    m=root(func,m-(val(func,m))/d,n-1);
    }
    float cheat=m;
    return cheat;
}
double slope(string c,double x)
{
   const char* str;
    str=c.c_str();
    return val(deriv_fn(str,"x"),x);
}
double xslope(string c,double x,double y)
{
    const char* str;
    str=c.c_str();
    return sval(deriv_fn(str,"x"),x,y);
}
double yslope(string c,double x,double y)
{
    const char* str;
    str=c.c_str();
    return sval(deriv_fn(str,"y"),x,y);
}
string convert(double n)
{
    char arr[20];
    sprintf(arr,"%f",n);
    string answer(arr);
    return answer;
}
/*double minfn(string c ,double low,double high)
{
    int i;
    const char* str;
    str=c.c_str();
    double minf[50];
    double* x;
    string dc(deriv_fn(str,"x"));

    x=dividensolve(dc,low,high,50);

    //for (i=0;i<50;i++){cout<<x[i];}
    int k=0;
    for (i=0;i<50;i++)
    {if ((x[i]<=high) && (x[i]>=low))
    {

           minf[k]=x[i];
           k++;
    }
    }
    delete[] x;
    double mnf=val(c,low);
    for (i=0;i<=k;i++)
    {
        if(minf[i]<mnf)
        {
            mnf=minf[i];
        }
    }

    if(val(c,high)<mnf){mnf=val(c,high);}
    return val(c,mnf);
}

double maxfn(string c ,double low,double high)

{
    int i;
    const char* str;
    str=c.c_str();
    double maxf[50];
    double* x;
    string dc(deriv_fn(str,"x"));
int k=0;
    x=dividensolve(dc,low,high,50);

    //for (i=0;i<50;i++){cout<<x[i];}
    for (i=0;i<50;i++)
    {if ((x[i]<=high) && (x[i]>=low))
    {

           maxf[k]=x[i];
           k++;
    }
    }
    delete[] x;
    double mxf=val(c,low);
    for (i=0;i<=k;i++)
    {
        if(maxf[i]>mxf)
        {
            mxf=maxf[i];
        }
    }

    if(val(c,low)>mxf){mxf=val(c,low);}

    if(val(c,high)>mxf){mxf=val(c,high);}
    return val(c,mxf);
}*/
void normal(string c,double x,double width)
{
    double low=x-width;
    double high=x+width;

    string tang="(x-";

    string tang2=convert(x);

    string tang3=")*";

    string tang4=convert(-1/slope(c,x));

    string tang5="+";

    string tang6=convert(val(c,x));

    string tangent=tang+tang2+tang3+tang4+tang5+tang6;

    double ylow=val(c,x)-width;
    double yhigh=val(c,x)+width;

    string multi="set terminal png;set output 'plot3.png';set size square;set multiplot;set xrange[";
    string mlt1=convert(low);
    string mlt2=":";
    string mlt3=convert(high);
    string mlt4="];set yrange[";
    string mlt5=convert(ylow);
    string mlt6=":";
    string mlt7=convert(yhigh);
    string mlt8="];plot ";
    string multi2="; set xrange[";
    string multi3=" lt rgb 'green' \"";
    string prompt="\"cmd.exe /c gnuplot -e \"";

    string both=prompt+multi+mlt1+mlt2+mlt3+mlt4+mlt5+mlt6+mlt7+mlt8+c+multi2+mlt1+mlt2+mlt3+mlt4+mlt5+mlt6+mlt7+mlt8+tangent+multi3;

    system(both.c_str());

    return;


}