#include <iostream>
#include <cstring>
#include <cstdio>


using namespace std;

/*
   -1. constants : 2*x;
   2. division;
   -3. algebraic;
   4. string syntax;
   5.warnings
   */


char* chain_rule(const char* fn,char var[]);
char* product_rule(const char* fn1,const char* fn2,char var[]);

char* deriv_exp(const char* fn)
{char *diff=new char[100];
strcpy(diff,"exp(");
strcat(diff,fn);
strcat(diff,")");
return diff;
}

char* deriv_log(const char*fn)//log(fn)
{char *diff=new char[100];
strcpy(diff,"1/(");
strcat(diff,fn);
strcat(diff,")");
return diff;
}

char* deriv_sin(const char* fn)//sin(fn)
{
char *diff=new char[100];
strcpy(diff," cos(");
strcat(diff,fn);
strcat(diff,")");
return diff;
}


char* deriv_cos(const char* fn)//cos(fn)
{
char *diff=new char[100];
strcpy(diff,"(-sin(");
strcat(diff,fn);
strcat(diff,"))");
return diff;
}

char* deriv_tan(const char* fn)//tan(fn)
{
char *diff=new char[100];
strcpy(diff,"(sec(");
strcat(diff,fn);
strcat(diff,"))^2");
return diff;
}

char* deriv_cosec(const char* fn)//cosec(fn)
{
char *diff=new char[100];
strcpy(diff,"(-1*cot(");
strcat(diff,fn);
strcat(diff,")");
strcat(diff,"cosec(");
strcat(diff,fn);
strcat(diff,"))");
return diff;
}

char* deriv_sec(const char* fn)//sec(fn)
{
char *diff=new char[100];
strcpy(diff,"tan(");
strcat(diff,fn);
strcat(diff,")");
strcat(diff,"sec(");
strcat(diff,fn);
strcat(diff,")");
return diff;
}

char* deriv_cot(const char* fn)//cot(fn)
{
char *diff=new char[100];
strcpy(diff,"(-(cosec(");
strcat(diff,fn);
strcat(diff,"))^2)");
return diff;
}


char* deriv_fn(const char* fn,char var[2])
{
char* deriv,part[50],part2[50];
deriv=new char[100];

strcpy(deriv,"");
strcpy(part2,"");

int i=0,c=0,k=0,flag=0;

if(fn[0]=='(')c++;

do
{
    part[k++]=fn[i++];

    if(fn[i]=='*'&&c==0)
    {part[k]='\0';
    flag=1;
    strcat(part2,part);
    k=0;i++;
    }

    if(fn[i]=='(')
        c++ ;


    if(((fn[i]=='+' ||fn[i]=='-')&& c==0)||fn[i]=='\0')
     {
         part[k]='\0';

         char* partder;

         switch(flag)
         {
             case 0:partder=chain_rule(part,var);
                    break;
             case 1:partder=product_rule(part,part2,var);
         }

        if(strcmp(partder,"constant")!=0)
         strcat(deriv,partder);

          if(fn[i]=='+')
            strcat(deriv,"+");

          if(fn[i]=='-')
            strcat(deriv,"-");

          delete[] partder;

         i++;
         k=0;flag=0;
     }

    if(fn[i]==')')
        c--;
}
while(i<strlen(fn));

/*if(deriv==NULL) return "Error";
if(strcmp(deriv,"")==0)
  strcat(deriv,"0");*/

return deriv;
}


char* chain_rule(const char* fn,char var[2])
{
char innerfn[100],op[10],*deriv;

strcpy(innerfn,"");

int i=0,c=0,j=0,k=0;

while(fn[i]!='\0')
{if(fn[i]=='(')
    c++;

if((c>0) && !( (fn[i]=='(' || fn[i]==')') && (c==1) ))
       innerfn[j++]=fn[i];

else
    if(c==0 && !(fn[i]==' '))
       op[k++]=fn[i];


if(fn[i]==')')
        c--;

i++;
}
innerfn[j]='\0';
op[k]='\0';

int flag=0;

if(strcmp(op,"sin")==0)
  {deriv=deriv_sin(innerfn);
    flag=1;}

if(strcmp(op,"cos")==0)
  {deriv=deriv_cos(innerfn);
    flag=1;}

if(strcmp(op,"tan")==0)
  {deriv=deriv_tan(innerfn);
   flag=1;}

if(strcmp(op,"sec")==0)
  {deriv=deriv_sec(innerfn);
  flag=1;}

if(strcmp(op,"cosec")==0)
  {deriv=deriv_cosec(innerfn);
  flag=1;}

if(strcmp(op,"cot")==0)
  {deriv=deriv_cot(innerfn);
  flag=1;}

if(strcmp(op,"log")==0)
  {deriv=deriv_log(innerfn);
  flag=1;}

if(strcmp(op,"exp")==0)
  {deriv=deriv_exp(innerfn);
  flag=1;}

if(strcmp(op,var)==0)
{
    deriv=new char[2];
    strcpy(deriv,"1");
    flag=1;
}

if(flag==0)
{
    c=0;k=1;
    char s[5];
    if(op[0]=='^')flag=1;

  if(flag==1){
  for(i=0;op[i]!='\0';i++)
     {
      if(isdigit(op[i]))
          s[c++]=op[i];
       }
    s[c]='\0';
    deriv=new char[100];
   strcpy(deriv,s);
   strcat(deriv,"*(");
   strcat(deriv,innerfn);
   strcat(deriv,")^");
   s[c-1]=s[c-1]--;
   strcat(deriv,s);
  }
}

if(flag==0)
    return "constant";

if(strcmp(innerfn,var)!=0 && innerfn[0]!='\0')
  {strcat(deriv,"* (");
    char * innerderiv=deriv_fn(innerfn,var);

     if(strcmp(innerderiv,"constant")!=0)
      {strcat(deriv,innerderiv);
       strcat(deriv,")");}

     else strcpy(deriv,"constant");

     delete[] innerderiv;
     }

return deriv;
}

char* product_rule(const char* fn1,const char* fn2,char var[2])
{
    char *deriv,*der1,*der2;

    der1=chain_rule(fn1,var);
    der2=chain_rule(fn2,var);

    deriv=new char[100];

   if(strcmp(der1,"constant")!=0 && strcmp(der2,"constant")!=0)
   {

     strcpy(deriv,fn1);
     strcat(deriv,"*");
     strcat(deriv,der2);
     strcat(deriv," + ");
     strcat(deriv,fn2);
     strcat(deriv,"*");
     strcat(deriv,der1);

     delete[] der1;
     delete[] der2;
     return deriv;}

    else
    {
        if(strcmp(der1,"constant")==0)
        {
             strcpy(deriv,fn1);
             strcat(deriv,"*");
             strcat(deriv,der2);
        }

        if(strcmp(der2,"constant")==0)
        {
             strcpy(deriv,fn2);
             strcat(deriv,"*");
             strcat(deriv,der1);
        }
    }


}


/*int main()
{
char fn[100],*deriv;

cout<<"give function : ";
cin>>fn;
deriv=deriv_fn(fn,"x");

cout<<deriv;

delete[] deriv;

return 0;
}*/
